/*
 File: t_alphabetsym.cpp
 Date and Time: Fri Jan 30 18:55:25 2015 
*/
#include "t_alphabet.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_t_alphabet;// grammar's ns
// first set terminals
// monolithic grammar --- no thread
void 
Ct_alphabet::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rt_alphabet_:{
       Rt_alphabet* sym;
     if(re->rule_ == 0){
       sym = new Rt_alphabet(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rt_alphabet*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 4;
    

     sym->op();
     return;}
    case rhs1_Reog_:{
       Reog* sym;
     if(re->rule_ == 0){
       sym = new Reog(parser__);
       re->rule_ = sym;
     }else{
       sym = (Reog*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_RT_alphabet_:{
       RT_alphabet* sym;
     if(re->rule_ == 0){
       sym = new RT_alphabet(parser__);
       re->rule_ = sym;
     }else{
       sym = (RT_alphabet*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_RT_alphabet_:{
       RT_alphabet* sym;
     if(re->rule_ == 0){
       sym = new RT_alphabet(parser__);
       re->rule_ = sym;
     }else{
       sym = (RT_alphabet*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr2();
     return;}
    case rhs1_Rlist_of_Ts_:{
       Rlist_of_Ts* sym;
     if(re->rule_ == 0){
       sym = new Rlist_of_Ts(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlist_of_Ts*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rlist_of_Ts_:{
       Rlist_of_Ts* sym;
     if(re->rule_ == 0){
       sym = new Rlist_of_Ts(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlist_of_Ts*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs3_Rlist_of_Ts_:{
       Rlist_of_Ts* sym;
     if(re->rule_ == 0){
       sym = new Rlist_of_Ts(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlist_of_Ts*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs1_Ra_T_:{
       Ra_T* sym;
     if(re->rule_ == 0){
       sym = new Ra_T(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ra_T*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_Rend_T_alphabet_:{
       Rend_T_alphabet* sym;
     if(re->rule_ == 0){
       sym = new Rend_T_alphabet(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rend_T_alphabet*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rend_T_alphabet_:{
       Rend_T_alphabet* sym;
     if(re->rule_ == 0){
       sym = new Rend_T_alphabet(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rend_T_alphabet*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr2();
     return;}
    default: return;
   }
}
